﻿# -*- coding: utf-8 -*-

from Plugins.Extensions.IPTVPlayer.compat import urlparse
from Plugins.Extensions.IPTVPlayer.libs.matrix.hosters.hoster import iHoster
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib import random_ua
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.comaddon import VSlog
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.handler.requestHandler import \
    cRequestHandler
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.parser import cParser

UA = random_ua.get_pc_ua()


class cHoster(iHoster):

    def __init__(self):
        iHoster.__init__(self, 'uploady', 'Uploady')

    def setUrl(self, sUrl):
        parsed_url = urlparse(sUrl)
        domain = parsed_url.netloc
        file_id = parsed_url.path.strip("/")
        self._url = f'https://{domain}/embed-{file_id}.html'

    def _getMediaLinkForGuest(self):
        VSlog(self._url)
        oParser = cParser()
        oRequest = cRequestHandler(self._url)
        oRequest.addHeaderEntry('User-Agent', UA)
        sHtmlContent = oRequest.request()

        sPattern = '''src: ["']([^"^']+)'''
        aResult = oParser.parse(sHtmlContent, sPattern)

        if aResult[0] is True:
            api_call = aResult[1][0]

        if api_call:
            return True, f'{api_call}|verifypeer=false&User-Agent={UA}'

        return False, False
