# -*- coding: utf-8 -*-


from importlib import import_module

from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.comaddon import (VSlog,
                                                                    addon,
                                                                    dialog)
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.gui.contextElement import \
    cContextElement
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.gui.gui import cGui
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.gui.guiElement import \
    cGuiElement
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.handler.inputParameterHandler import \
    cInputParameterHandler
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.handler.outputParameterHandler import \
    cOutputParameterHandler

try:
    import resolveurl
except ImportError:
    pass


class cHosterGui:
    SITE_NAME = 'cHosterGui'
    ADDON = addon()

    # step 1 - bGetRedirectUrl in ein extra optionsObject verpacken
    def showHoster(self, oGui, oHoster, sMediaUrl, sThumbnail, bGetRedirectUrl=False):
        oHoster.setUrl(sMediaUrl)
        oOutputParameterHandler = cOutputParameterHandler()
        oInputParameterHandler = cInputParameterHandler()

        # Gestion NextUp
        siteUrl = oInputParameterHandler.getValue('siteUrl')
        site = oInputParameterHandler.getValue('site')
        saisonUrl = oInputParameterHandler.getValue('saisonUrl')
        sSeason = oInputParameterHandler.getValue('sSeason')
        sEpisode = oInputParameterHandler.getValue('sEpisode')
        nextSaisonFunc = oInputParameterHandler.getValue('nextSaisonFunc')
        movieUrl = oInputParameterHandler.getValue('movieUrl')
        movieFunc = oInputParameterHandler.getValue('movieFunc')
        sLang = oInputParameterHandler.getValue('sLang')
        sRes = oInputParameterHandler.getValue('sRes')
        sTmdbId = oInputParameterHandler.getValue('sTmdbId')
        if not (sFav := oInputParameterHandler.getValue('sFav')):
            sFav = oInputParameterHandler.getValue('function')
        if (searchSiteId := oInputParameterHandler.getValue('searchSiteId')):
            oOutputParameterHandler.addParameter('searchSiteId', searchSiteId)
        oOutputParameterHandler.addParameter('searchSiteName', oInputParameterHandler.getValue('searchSiteName'))
        oOutputParameterHandler.addParameter('sQual', oInputParameterHandler.getValue('sQual'))

        oGuiElement = cGuiElement()
        oGuiElement.setSiteName(self.SITE_NAME)
        oGuiElement.setFunction('play')

        # Catégorie de lecture
        if oInputParameterHandler.exist('sCat'):
            sCat = oInputParameterHandler.getValue('sCat')
            if sCat == '4':  # Si on vient de passer par un menu "Saison" ...
                sCat = '8'   # ...  On est maintenant au niveau "Episode"
        else:
            sCat = '5'     # Divers

        oGuiElement.setCat(sCat)
        oOutputParameterHandler.addParameter('sCat', sCat)

        if (oInputParameterHandler.exist('sMeta')):
            sMeta = oInputParameterHandler.getValue('sMeta')
            oGuiElement.setMeta(sMeta)

        oGuiElement.setFileName(oHoster.getFileName())
        oGuiElement.getInfoLabel()
        oGuiElement.setIcon('host.png')
        if sThumbnail:
            oGuiElement.setThumbnail(sThumbnail)
            oGuiElement.setPoster(sThumbnail)

        if (sMediaFile := oHoster.getMediaFile()):  # Afficher le nom du fichier plutot que le titre
            oGuiElement.setMediaUrl(sMediaFile)
            if self.ADDON.getSetting('display_info_file') == 'true':
                oHoster.setDisplayName(sMediaFile)
                oGuiElement.setTitle(oHoster.getFileName())  # permet de calculer le cleanTitle
                oGuiElement.setRawTitle(oHoster.getDisplayName())   # remplace le titre par le lien
            else:
                oGuiElement.setTitle(oHoster.getDisplayName())
        else:
            oGuiElement.setTitle(oHoster.getDisplayName())

        title = oGuiElement.getCleanTitle()
        tvShowTitle = oGuiElement.getItemValue('tvshowtitle')

        oOutputParameterHandler.addParameter('sMediaUrl', sMediaUrl)
        oOutputParameterHandler.addParameter('sHosterIdentifier', oHoster.getPluginIdentifier())
        oOutputParameterHandler.addParameter('bGetRedirectUrl', bGetRedirectUrl)
        oOutputParameterHandler.addParameter('sFileName', oHoster.getFileName())
        oOutputParameterHandler.addParameter('sTitleWatched', oGuiElement.getTitleWatched())
        oOutputParameterHandler.addParameter('tvShowTitle', tvShowTitle)
        oOutputParameterHandler.addParameter('sTitle', title)
        oOutputParameterHandler.addParameter('sSeason', sSeason)
        oOutputParameterHandler.addParameter('sEpisode', sEpisode)
        oOutputParameterHandler.addParameter('sLang', sLang)
        oOutputParameterHandler.addParameter('sRes', sRes)
        oOutputParameterHandler.addParameter('sId', 'cHosterGui')
        oOutputParameterHandler.addParameter('siteUrl', siteUrl)
        oOutputParameterHandler.addParameter('sTmdbId', sTmdbId)

        # gestion NextUp
        oOutputParameterHandler.addParameter('sourceName', site)    # source d'origine
        oOutputParameterHandler.addParameter('sourceFav', sFav)    # source d'origine
        oOutputParameterHandler.addParameter('nextSaisonFunc', nextSaisonFunc)
        oOutputParameterHandler.addParameter('saisonUrl', saisonUrl)

        # gestion Lecture en cours
        oOutputParameterHandler.addParameter('movieUrl', movieUrl)
        oOutputParameterHandler.addParameter('movieFunc', movieFunc)

        # Download menu
        if oHoster.isDownloadable():
            oContext = cContextElement()
            oContext.setFile('cDownload')
            oContext.setSiteName('cDownload')
            oContext.setFunction('AddtoDownloadList')
            oContext.setTitle(self.ADDON.VSlang(30202))
            oContext.setOutputParameterHandler(oOutputParameterHandler)
            oGuiElement.addContextItem(oContext)

            # Beta context download and view menu
            oContext = cContextElement()
            oContext.setFile('cDownload')
            oContext.setSiteName('cDownload')
            oContext.setFunction('AddtoDownloadListandview')
            oContext.setTitle(self.ADDON.VSlang(30326))
            oContext.setOutputParameterHandler(oOutputParameterHandler)
            oGuiElement.addContextItem(oContext)

        # Liste de lecture
        oContext = cContextElement()
        oContext.setFile('cHosterGui')
        oContext.setSiteName(self.SITE_NAME)
        oContext.setFunction('addToPlaylist')
        oContext.setTitle(self.ADDON.VSlang(30201))
        oContext.setOutputParameterHandler(oOutputParameterHandler)
        oGuiElement.addContextItem(oContext)

        # Dossier Media
        oGui.createSimpleMenu(oGuiElement, oOutputParameterHandler, 'cLibrary', 'cLibrary', 'setLibrary', self.ADDON.VSlang(30324))

        # Upload menu uptobox
        if cInputParameterHandler().getValue('site') != 'siteuptobox' and self.ADDON.getSetting('hoster_uptobox_premium') == 'true':
            host = oHoster.getPluginIdentifier()
            accept = ['uptobox', 'uptostream', '1fichier', 'uploaded', 'uplea']
            for i in accept:
                if host == i:
                    oGui.createSimpleMenu(oGuiElement, oOutputParameterHandler, 'siteuptobox', 'siteuptobox', 'upToMyAccount', self.ADDON.VSlang(30325))
                    break

        # onefichier
        if cInputParameterHandler().getValue('site') != 'siteonefichier' and self.ADDON.getSetting('hoster_onefichier_premium') == 'true':
            host = oHoster.getPluginIdentifier()
            accept = '1fichier'  # les autres ne fonctionnent pas
            if host == accept:
                oGui.createSimpleMenu(oGuiElement, oOutputParameterHandler, 'siteonefichier', 'siteonefichier', 'upToMyAccount', '1fichier')

        oGui.addFolder(oGuiElement, oOutputParameterHandler, False)

    def checkHoster(self, sHosterUrl, debrid=True):
        # securite
        if not sHosterUrl:
            return False

        # Petit nettoyage
        sHosterUrl = sHosterUrl.split('|')[0]
        sHosterUrl = sHosterUrl.split('?')[0]
        sHosterUrl = sHosterUrl.lower()

        # Recuperation du host
        try:
            sHostName = sHosterUrl.split('/')[2]
        except:
            sHostName = sHosterUrl

        if debrid:
            if self.ADDON.getSetting('Userresolveurl') == 'true':
                hmf = resolveurl.HostedMediaFile(url=sHosterUrl)
                if hmf.valid_url():
                    tmp = self.getHoster('resolver')
                    RH = sHosterUrl.split('/')[2]
                    RH = RH.replace('www.', '')
                    tmp.setRealHost(RH.split('.')[0].upper())
                    return tmp

            # L'user a activé alldebrid ?
            if self.ADDON.getSetting('hoster_alldebrid_premium') == 'true':
                f = self.getHoster('alldebrid')
                # mise a jour du nom
                f.setRealHost(sHostName)
                return f

            # L'user a activé realbrid ?
            if self.ADDON.getSetting('hoster_realdebrid_premium') == 'true':
                f = self.getHoster('realdebrid')
                # mise a jour du nom
                f.setRealHost(sHostName)
                return f

            # L'user a activé debrid_link ?
            if self.ADDON.getSetting('hoster_debridlink_premium') == 'true':
                if "debrid.link" not in sHosterUrl:
                    return self.getHoster('debrid_link')
                else:
                    return self.getHoster("lien_direct")

        supported_player = [
            'film77', 'hdup', 'streamable', 'stardima', 'filescdn', 'vidgot', 'videott', 'vidlo', 'sendit', 'thevid', 'vidmoly', 'gettyshare',
            'fastplay', 'cloudy', 'hibridvod', 'extremenow', 'yourupload', 'vidspeeds', 'moshahda', 'voe', 'faselhd', 'naqoos', 'frdl',
            'streamax', 'gounlimited', 'xdrive', 'facebook', 'mixdrop', 'mixloads', 'vidoza', 'rutube', 'megawatch', 'vidzi', 'filetrip',
            'speedvid', 'letsupload', 'krakenfiles', 'onevideo', 'playreplay', 'vidfast', 'uqload', 'qiwi', 'gofile', 'mail.ru', 'videas',
            'letwatch', 'mp4upload', 'filepup', 'vimple', 'wstream', 'watchvideo', 'vidwatch', 'up2stream', 'tune', 'playtube', 'extrashare',
            'vidup', 'vidbull', 'vidlox', '33player' 'easyload', 'ninjastream', 'cloudhost', 'videobin', 'stagevu', 'gorillavid', 'soraplay',
            'daclips', 'hdvid', 'vshare', 'vidload', 'giga', 'vidbom', 'cloudvid', 'megadrive', 'downace', 'clickopen', 'supervideo', 'veev',
            'turbovid', 'soundcloud', 'mixcloud', 'ddlfr', 'vupload', 'dwfull', 'vidzstore', 'pdj', 'rapidstream', 'vidyard', '1cloud', 'uploady',
            'dustreaming', 'viki', 'flix555', 'onlystream', 'upstream', 'pstream', 'vudeo', 'vidia', 'vidbem', 'uplea', 'vido', 'streamhub',
            'sibnet', 'vidplayer', 'userload', 'aparat', 'evoload', 'abcvideo', 'plynow', '33player', 'filerio', 'videoraj', 'streamvid',
            'brightcove', 'detectiveconanar', 'myvi', '33player', 'videovard', 'viewsb', 'yourvid', 'vf-manga', 'oneupload', 'darkibox', 'hexupload']

        if (val := next((x for x in supported_player if x in sHostName), None)):
            return self.getHoster(val.replace('.', ''))

        # Vidshare Clone
        vidshare = next((x for x in [
            'vadshar', 'vidshar', 'vedshaar', 'vedsharr', 'vedshar', 'vedshar', 'vidshare', 'viidshar', 'vid1shar', '2vid2cdnshar', 'v2d2shr',
            'v1d1shr', 'v3dsh1r', 'vds3r', 'v3dshr', 'vndsh1r', 'vd12s3r', 'v31dshr', 'vds1r', 'vdonlineshr', 'v4dshnr', 'vd1sher',
            'vd13r', 'vd1sr', 'v1dsr', 'vd2sr', 'v1d2sr', 'v2d3sr', 'vd4sr', 'vadsr', 'van1dsr', 'vv1dsr', 'viidhdr', 'va1dsr', 'vd5sr', '1vid1shar'] if x in sHostName), None)
        if vidshare:
            return self.getHoster('vidshare')

        # Vidbom Clone
        vidbom = next((x for x in [
            'vidbom', 'vidbm', 'vadbam', 'vedbom', 'vadbom', 'vidbam', 'vedbam', 'viboom', 'vid1bom', 'viid2beem', 'viid1boom',
            'ved2om', 'vid2bom', 'viidboom', 'vig1bm', 'v3db1oom', 'ved1om', 'vvid1om', 'vigom', 've1dp3m', 'vdp1em', 'viid1bem', 'vuidbeaam',
            'v2ddb3m', '2vbiim', 'vdb123m', 'vd123bm', 'v3dbeam', 'v3dbtom', 'v7d20bm', 'v7d20bm', 'vdtom', 'vendm', 'vandbm', 'vand1bm',
            'vrdb2m', 'vdbt3om', 'vd22tom', 'ven1dm', 'vrdtem', 'vrd1tem', 'v5db2m', 'vdb1m', 'vendbm', 'v6b3m', 'vd1bm', 'vdb2m', 'v1db2m',
            'v2db3m', 'vd3bm', 'venb1m', 'v1enbm', 'vndtom', 'v1dbm', 'vd5bm', 'vdbtm'] if x in sHostName), None)
        if vidbom:
            return self.getHoster('vidbom')

        # Uppom Clone
        uppom = next((x for x in [
            'upbaam', 'upbam', 'uppom', 'uppboom', 'uupbom', 'upgobom', 'upptobom', 'up2b9om', 'up1bom', 'up3bom', 'u1pb3m',
            'u2pbemm', 'up1beem', 'bmbm.shop', '4bmto', '2bm.shop', 't0bm4.shop', '4bem2022', 'bm025', 'bm2024', 'b245m.shop', 'b2m1.shop',
            'online20.shop', 'line50.shop', 'fo0.shop', 'online20stream', '4view.shop', 'team20.shop', 'travel15.shop', 'sigh15.shop',
            'video15.shop', 'streaming15.shop', 'onlin12estream', 'tostream20', 'streaming200', 'top15top', 'uppbom'] if x in sHostName), None)
        if uppom:
            return self.getHoster('uppom')

        # Govidme Clone
        govidme = (next((x for x in [
            'govad', 'govid.me', 'goveed', 'go2ved', 'go1ved', 'go-veid', 'g1v3d', 'goo1vd', 'g2ev4d', 'ge1verd', 'g1oov1d',
            'ga1ov3d', '1gafv3d', 'go12d', 'go1v2d', 'gonvd1', 'gaonv3d', 'gonv20d', 'goevd', 'goanvd', 'goanv1d', 'gonvnd', 'gvnd',
            'gaonvd', 'go1evd', 'goverd', 'gnvd', 'go1vend', 'go1vd', 'go2vd', 'go4vd', 'gov7d', 'gon1vd', 'goov9d', 'goov1d', 'goov2d',
            'gov9d', 'gov8d', 'g1ovd', 'goveed1'] if x in sHostName), None))
        if govidme:
            return self.getHoster('govidme')

        # Streamwish Clone
        streamwish = next((x for x in [
            'streamwish', 'khadhnayad', 'ajmidyad', 'yadmalik', 'kharabnah', 'hayaatieadhab', 'sfastwish', 'eghjrutf', 'eghzrutw',
            'wishfast', 'fviplions', 'egtpgrvh', 'mdy48tn97', 'embedwish', 'fsdcmo.sbs', 'anime4low', 'cdnwish-down', 'heavenlyvideo',
            'flaswish', 'streamzid', 'cimawish', 'egopxutd', 'obeywish', 'trgsfjll', 'mdbekjwqa', 'uqloads', 'm3lomatik', 'cdnwish', 'ma2d',
            'mohahhda', 'asnwish', 'jodwish', 'cinemathek', 'swhoi', 'dancima', 'warda', 'gsfqzmqu', 'swdyu', 'cinemabest.online'] if x in sHostName), None)
        if streamwish:
            return self.getHoster('streamwish')

        # Frenchvid Clone
        frenchvid = next((x for x in [
            'french-vid', 'diasfem', 'yggseries', 'fembed', 'fem.tohds', 'feurl', 'fsimg', 'core1player',
            'vfsplayer', 'gotochus', 'suzihaza', 'sendvid', "femax"] if x in sHostName), None)
        if frenchvid:
            return self.getHoster("frenchvid")

        # Filelions Clone
        filelions = next((x for x in [
            'filelions', 'ajmidyadfihayh', 'alhayabambi', 'bazwatch', 'cilootv', 'motvy55', 'bazlions', 'lylxan',
            'fdewsdc.sbs', '5drama.vip', 'cdnlion-down', 'demonvideo', 'zidlions', 'vidhide', 'streamfile', 'vidnow', 'tuktukcinema29.buzz', 'gsfomqu', 'codeda', 'ma3refa.store', 'coolciima', 'nejma', 'cinmabest.site'] if x in sHostName), None)
        if filelions:
            return self.getHoster("filelions")

        # Vidguard Clone
        if next((x for x in ['vidguard', 'fertoto', 'vgembed', 'vgfplay', 'vembed', 'vid-guard', 'jetload', 'embedv', 'fslinks', 'bembed', 'listeamed', 'gsfjzmqu'] if x in sHostName), None):
            return self.getHoster("vidguard")

        # Vidtodo clone
        if next((x for x in ['vidtodo', 'vixtodo', 'viddoto', 'vidstodo'] if x in sHostName), None):
            return self.getHoster('vidtodo')

        # Filemoon Clone
        if next((x for x in ['filemoon', 'moonmov', 'allviid', 'all-vid', 'techradar', 'albrq', 'kerapoxy', 'kerapoxy'] if x in sHostName), None):
            return self.getHoster("filemoon")

        # Voe Clone
        if next((x for x in ['voe', 'kathleenmemberhistory', 'timberwoodanotia', 'stevenimaginelittle', 'availedsmallest', 'monorhinouscassaba', 'jamiesamewalk', 'graceaddresscommunity', 'shannonpersonalcost', 'michaelapplysome', 'brucevotewithin'] if x in sHostName), None):
            return self.getHoster("voe")

        # vidlo Clone
        if next((x for x in ['vidlo', 'c13-look', '7c3-look'] if x in sHostName), None):
            return self.getHoster('vidlo')

        # dood Clone
        if (dood := next((x for x in ['DoodStream', 'dooood', 'flixeo', 'ds2play', 'dood', 'd0o0d', 'ds2video', 'do0od', 'd0000d', 'd000d'] if x in sHostName), None)):
            return self.getHoster('dood')

        # chillx Clone
        if next((x for x in ['chillx', 'vectorx', 'boltx', 'bestx'] if x in sHostName), None):
            return self.getHoster('chillx')

        # mcloud Clone
        if next((x for x in ['mcloud', 'vizcloud', 'vidstream', 'vidplay', '55a0716b8c', 'e69975b881', 'c8365730d4'] if x in sHostName), None):
            return self.getHoster('mcloud')

        if ('vidsrc.stream' in sHostName):
            return self.getHoster('vidsrcstream')

        if ('multiembed' in sHostName):
            return self.getHoster('multiembed')

        # cimacafe Clone
        if next((x for x in ['cimacafe', 'egbist'] if x in sHostName), None):
            return self.getHoster('cimacafe')

        if ('hexload' in sHostName):
            return self.getHoster('hexupload')

        if ('extreamnow' in sHostName):
            return self.getHoster('extremenow')

        if ('2embed.me' in sHostName):
            return self.getHoster('2embedme')

        if ('short.ink' in sHostName):
            return False

        if ('remotestre.am' in sHostName):
            return self.getHoster('remotestream')

        # mixdroop Clone
        if next((x for x in ['mixdroop', 'mdfx9dc8n', 'mdzsmutpcvykb'] if x in sHostName), None):
            return self.getHoster('mixdroop')

        if ('drop.download' in sHostName):
            return self.getHoster('drop')

        if ('clicknupload' in sHostName):
            return self.getHoster('clicknupload')

        if ('.aflam' in sHosterUrl):
            return self.getHoster('mixloads')

        # viewsb Clone
        if next((x for x in ['sbfull', 'sbrapid', 'sbhight', 'sbface'] if x in sHostName), None):
            return self.getHoster('viewsb')

        if ('upstream' in sHosterUrl):
            return self.getHoster('upstream')

        if ('wolfstream' in sHosterUrl):
            return self.getHoster('aparat')

        if ('vanfem' in sHostName):
            return self.getHoster('fembed')

        # vidtube Clone
        if next((x for x in ['vidtube', 'vtbe'] if x in sHostName), None):
            return self.getHoster('vidtube')

        if ('updown' in sHostName):
            return self.getHoster('updown')

        # xvideo Clone
        if next((x for x in ['vod540', 'hd-cdn', 'anyvid', 'vod7', 'segavid', 'vidblue', 'arabveturk', 'filegram'] if x in sHostName), None):
            return self.getHoster('xvideo')

        if ('diasfem' in sHosterUrl):
            return self.getHoster('fembed')

        # streamtape Clone
        if next((x for x in ['streamtape', 'streamnoads', 'tapenoads'] if x in sHostName), None):
            return self.getHoster('streamtape')

        if ('lanesh' in sHosterUrl):
            return self.getHoster('lanesh')

        # lulustream Clone
        if next((x for x in ['lulustream', 'luluvdo', 'luluvid'] if x in sHostName), None):
            return self.getHoster('lulustream')

        # rubystream Clone
        if next((x for x in ['rubystream', 'tuktukmulti', 'stmruby', 'streamruby'] if x in sHostName), None):
            return self.getHoster('rubystream')

        if ('asiawiki' in sHostName):
            return self.getHoster('asiadtv')

        if ('asiatvplayer' in sHostName):
            return self.getHoster('asiadtv')

        if ('vimeo' in sHostName):
            return self.getHoster('vimeo')

        # cimanow Clone
        if next((x for x in ['rrsrrs', 'cimanow.net'] if x in sHostName), None):
            return self.getHoster('cimanow')

        if ('embed.scdn.' in sHostName):
            return self.getHoster('faselhd')

        if ('/run/' in sHosterUrl):
            return self.getHoster('mycima')

        # lien_direct Clone
        if next((x for x in [
            'megaupload.', 'fansubs', 'us.archive.', 'ddsdd', 'ffsff', 'rrsrr', 'fbcdn.net', 'blogspot.com', 'videodelivery', 'bittube', 'amazonaws.com',
                '.googleusercontent.com', 'archive.org/download', 'iptvtree', 'ugeen', 'ak-download', 'nextcdn', 'akwam', 'onesav', 'akoams.com', '.vimeocdn.',
                'bokracdn', 'gcdn', 'alarabiya', 'kingfoot', 'livestream', 'myfiles.alldebrid.com', 'clientsportals', 'hadara.ps'] if x in sHostName), None):
            return self.getHoster('lien_direct')

        # lien_direct Clone
        if any(sHosterUrl.endswith(x) for x in ['.mp4', '.avi', '.flv', '.m3u8', '.webm', '.mkv', '.mpd']):
            return self.getHoster('lien_direct')

        if ('rumble' in sHostName):
            return self.getHoster('rumble')

        if ('file-upload' in sHostName):
            return self.getHoster('fileupload')

        if ('download.gg' in sHostName):
            return self.getHoster('downloadgg')

        if ('vidspeed' in sHostName):
            return self.getHoster('vidspeeds')

        # linkbox Clone
        if next((x for x in ['linkbox', 'sharezweb', 'lbx.to'] if x in sHostName), None):
            return self.getHoster('linkbox')

        if ('mediafire' in sHostName):
            return self.getHoster('mediafire')

        if ('workupload' in sHostName):
            return self.getHoster('workupload')

        # streamrapid Clone
        if next((x for x in ['rabbitstream', 'dokicloud'] if x in sHostName), None):
            return self.getHoster('streamrapid')

        if ('veehd.' in sHostName):
            return self.getHoster('veehd')

        if ('eeggyy' in sHosterUrl):
            return self.getHoster('egybest')

        if ('vidhls' in sHosterUrl):
            return self.getHoster('vidhls')

        if ('play.imovietime' in sHosterUrl):
            return self.getHoster('moviztime')

        if ('send.cm' in sHosterUrl):
            return self.getHoster('sendme')

        # shoffree Clone
        if next((x for x in ['shoffree', 'egy-best', 'site-panel.click', 'anime4up', 'anme4up7', 'egybest'] if x in sHostName), None):
            return self.getHoster('shoffree')

        # streamz Clone
        if next((x for x in ['streamsforu', 'ylass', 'rsc.cdn', 'btolat'] if x in sHostName), None):
            return self.getHoster('streamz')

        if ('archive.org/embed/"' in sHostName):
            return self.getHoster('archive')

        # anavids Clone
        if next((x for x in ['anavids', 'anavidz'] if x in sHostName), None):
            return self.getHoster('anavids')

        # streamhide Clone
        if next((x for x in ['streamhide', 'guccihide', 'fanakishtuna', 'ahvsh', 'animezd', 'anime7u', 'vidroba'] if x in sHostName), None):
            return self.getHoster('streamhide')

        # anonfile Clone
        if next((x for x in ['anonfile', 'govid.xyz', 'file.bz', 'myfile.is', 'upload.st'] if x in sHostName), None):
            return self.getHoster('anonfile')

        # cloudvid Clone
        if next((x for x in ['cloudvideo', 'streamcloud', 'userscloud'] if x in sHostName), None):
            return self.getHoster('cloudvid')

        # myvid Clone
        if next((x for x in ['myvid', 'myviid'] if x in sHostName), None):
            return self.getHoster('myvid')

        # govid Clone
        if next((x for x in ['govid', 'nowvid', 'vegaasvid', 'g1ovd', 'drkvid', 'gvid.', 'govid.', 'kopatube', 'kobatube', 'darkveed', 'downvol', 'telvod'] if x in sHostName), None):
            return self.getHoster('govid')

        # skyvid Clone
        if next((x for x in ['skyvid', 'gvadz'] if x in sHostName), None):
            return self.getHoster('skyvid')

        # arabseed Clone
        if next((x for x in ['reviewtech', 'reviewrate', 'seeeed', 'techinsider', 'gamezone.cam'] if x in sHostName), None):
            return self.getHoster('arabseed')

        if ('4shared' in sHostName):
            return self.getHoster('shared')

        if ('fajer.live' in sHostName):
            return self.getHoster('fajerlive')

        if ('cimaclub' in sHostName):
            return self.getHoster('cimaclub')

        if ('vid4up' in sHostName):
            return self.getHoster('vidforup')

        if ('fajer.video' in sHostName):
            return self.getHoster('fajer')

        # youtube Clone
        if next((x for x in ['youtube', 'youtu.be'] if x in sHostName), None):
            return self.getHoster('youtube')

        # samashare Clone
        if next((x for x in ['sama-share', 'vidpro'] if x in sHostName), None):
            return self.getHoster('samashare')

        # anafasts Clone
        if next((x for x in ['anafast', 'anamov', 'anaturk'] if x in sHostName), None):
            return self.getHoster('anafasts')

        if ('myvi.' in sHostName):
            return self.getHoster('myvi')

        # youdbox Clone
        if next((x for x in ['youdbox', 'yodbox', 'youdboox'] if x in sHostName), None):
            return self.getHoster('youdbox')

        # streamhide Clone
        if next((x for x in ['yandex', 'yadi.sk'] if x in sHostName), None):
            return self.getHoster('yadisk')

        # vidbem Clone
        if next((x for x in ['vidbem', 'vedpom'] if x in sHostName), None):
            return self.getHoster('vidbem')

        if ('vkplay' in sHostName):
            return self.getHoster('vkplay')

        if ('sharecast' in sHostName):
            return self.getHoster('sharecast')

        if ('live7' in sHostName):
            return self.getHoster('live7')

        if ('voodc' in sHostName):
            return self.getHoster('voodc')

        # vk Clone
        if next((x for x in ['vk.com', 'vkontakte', 'vkcom', 'vk.ru'] if x in sHostName), None):
            return self.getHoster('vk')

        if ('megaup.net' in sHostName):
            return self.getHoster('megaup')

        if ('playvidto' in sHostName):
            return self.getHoster('vidto')

        # qfilm Clone
        if next((x for x in ['qfilm', 'liiivideo', 'almstba'] if x in sHostName), None):
            return self.getHoster('qfilm')

        if ('hd-stream' in sHostName):
            return self.getHoster('hd_stream')

        # dailymotion Clone
        if next((x for x in ['dailymotion', 'dai.ly'] if x in sHostName), None):
            if 'stream' in sHosterUrl:
                return self.getHoster('lien_direct')
            return self.getHoster('dailymotion')

        # flashx Clone
        if next((x for x in ['flashx', 'filez'] if x in sHostName), None):
            return self.getHoster('flashx')

        # mystream Clone
        if next((x for x in ['mystream', 'mstream'] if x in sHostName), None):
            return self.getHoster('mystream')

        # speedvideo Clone
        if next((x for x in ['speedvideo', 'streamingentiercom/videophp?type=speed'] if x in sHostName), None):
            return self.getHoster('speedvideo')

        # googlevideo Clone
        if next((x for x in ['googlevideo', 'picasaweb', 'googleusercontent'] if x in sHostName), None):
            return self.getHoster('googlevideo')

        # ok_ru Clone
        if next((x for x in ['ok.ru', 'odnoklassniki'] if x in sHostName), None):
            return self.getHoster('ok_ru')

        if ('iframe-secured' in sHostName):
            return self.getHoster('iframe_secured')

        if ('iframe-secure' in sHostName):
            return self.getHoster('iframe_secure')

        # thevideo_me Clone
        if next((x for x in ['thevideo', 'video.tt', 'vev.io'] if x in sHostName), None):
            return self.getHoster('thevideo_me')

        if ('stream.moe' in sHostName):
            return self.getHoster('streammoe')

        # wholecloud Clone
        if next((x for x in ['wholecloud', 'movshare'] if x in sHostName), None):
            return self.getHoster('wholecloud')

        if ('upvid.' in sHostName):
            return self.getHoster('upvid')

        if ('dynamicrevival' in sHostName):
            return self.getHoster('dynamic')

        # upvideo Clone
        if next((x for x in ['upvideo', 'streamon'] if x in sHostName), None):
            return self.getHoster('upvideo')

        # upvid Clone
        if next((x for x in ['upvid', 'opvid'] if x in sHostName), None):
            return self.getHoster('upvid')

        # estream Clone
        if next((x for x in ['estream', 'widestream'] if x in sHostName), None):
            return self.getHoster('estream')

        # clipwatching Clone
        if next((x for x in ['clipwatching', 'highstream'] if x in sHostName), None):
            return self.getHoster('clipwatching')

        # allow_redirects Clone
        if next((x for x in ['goo.gl', 'bit.ly', 'streamcrypt', 'opsktp'] if x in sHostName), None):
            return self.getHoster('allow_redirects')

        # netu Clone
        if next((x for x in ['netu', 'waaw', 'hqq', 'doplay', 'vizplay'] if x in sHostName), None):
            return self.getHoster('netu')

        # directmoviedl Clone
        if next((x for x in ['directmoviedl', 'moviesroot'] if x in sHostName), None):
            return self.getHoster('directmoviedl')

        # uploaded Clone
        if next((x for x in ['uploaded', 'ul.to'] if x in sHostName), None):
            if '/file/forbidden' in sHosterUrl:
                return False
            return self.getHoster('uploaded')

        # torrent Clone
        if next((x for x in ['torrent', 'magnet'] if x in sHostName), None):
            return self.getHoster('torrent')

        if next((x for x in [
            'nitroflare', 'tubeload.', 'Facebook', 'fastdrive', 'megaup.net', 'openload', 'vidhd', 'ddownload', 'bowfile', 'uptobox', 'jawcloud', 'videomega',
                'oktube', 'mdiaload', 'fikper', 'turbobit', '1fichier', 'mega.nz', 'rapidgator', 'uptostream', 'wahmi', 'doodrive', 'highload', 'anonfiles',
                'prostream', 'fembed', 'filegage', 'streamlare'] if x in sHostName), None):
            return False

        # tuktuk Clone
        if next((x for x in ['tuktuk', 'volvovideo', 'lumiawatch'] if x in sHostName), None):
            return self.getHoster('tuktuk')

        if ('demonvid' in sHostName):
            return self.getHoster('demonvid')

        if ('avideo.host' in sHosterUrl):
            return self.getHoster('avideo')

        if ('hd-cdn' in sHosterUrl):
            return self.getHoster('hdcdn')

        else:
            # If no builtin resolver then let's try resolveURL:
            f = self.getHoster('resolver')
            f.setRealHost(sHostName)
            return f

    def getHoster(self, sHosterFileName):
        mod = import_module(f'Plugins.Extensions.IPTVPlayer.libs.matrix.hosters.{sHosterFileName}')
        klass = getattr(mod, 'cHoster')
        return klass()

    def play(self):
        oDialog = dialog()

        if not oInputParameterHandler:
            oInputParameterHandler = cInputParameterHandler()
        sHosterIdentifier = oInputParameterHandler.getValue('sHosterIdentifier')
        sMediaUrl = oInputParameterHandler.getValue('sMediaUrl')
        bGetRedirectUrl = oInputParameterHandler.getValue('bGetRedirectUrl')
        sFileName = oInputParameterHandler.getValue('sFileName')
        if not (sTitle := oInputParameterHandler.getValue('sTitle')):
            sTitle = sFileName
        siteUrl = oInputParameterHandler.getValue('siteUrl')
        sCat = oInputParameterHandler.getValue('sCat')
        sMeta = oInputParameterHandler.getValue('sMeta')

        if bGetRedirectUrl == 'True':
            sMediaUrl = self.__getRedirectUrl(sMediaUrl)

        try:
            mediaDisplay = sMediaUrl.split('/')
            VSlog(f"Hoster {sHosterIdentifier} - play : {'/'.join(mediaDisplay[0:3])}/ ... /{mediaDisplay[-1]}")
        except:
            VSlog(f"Hoster {sHosterIdentifier} - play : {sMediaUrl}")

        oHoster = self.getHoster(sHosterIdentifier)
        oHoster.setFileName(sFileName)

        sHosterName = oHoster.getDisplayName()
        oDialog.VSinfo(sHosterName, 'Resolve')

        try:
            oHoster.setUrl(sMediaUrl)
            aLink = oHoster.getMediaLink()

            if aLink and (aLink[0] or aLink[1]):  # Le hoster ne sait pas résoudre mais a retourné une autre url
                if not aLink[0]:  # Voir exemple avec allDebrid qui : return False, URL
                    if (oHoster := self.checkHoster(aLink[1], debrid=False)):
                        oHoster.setFileName(sFileName)
                        sHosterName = oHoster.getDisplayName()
                        oDialog.VSinfo(sHosterName, 'Resolve')

                        oHoster.setUrl(aLink[1])
                        aLink = oHoster.getMediaLink()

                if aLink[0]:
                    oGuiElement = cGuiElement()
                    oGuiElement.setSiteName(self.SITE_NAME)
                    oGuiElement.setSiteUrl(siteUrl)
                    oGuiElement.setMediaUrl(aLink[1])
                    oGuiElement.setFileName(sFileName)
                    oGuiElement.setCat(sCat)
                    oGuiElement.setMeta(sMeta)
                    oGuiElement.setTitle(sTitle)
                    oGuiElement.getInfoLabel()

                    from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.player import \
                        cPlayer
                    oPlayer = cPlayer(oInputParameterHandler)

                    # sous titres ?
                    if len(aLink) > 2:
                        oPlayer.AddSubtitles(aLink[2])

                    return oPlayer.run(oGuiElement, aLink[1])

            oDialog.VSerror(self.ADDON.VSlang(30020))
            return

        except Exception as e:
            oDialog.VSerror(self.ADDON.VSlang(30020))
            import traceback
            traceback.print_exc()
            return

    def addToPlaylist(self):
        oGui = cGui()
        oInputParameterHandler = cInputParameterHandler()
        sHosterIdentifier = oInputParameterHandler.getValue('sHosterIdentifier')
        sMediaUrl = oInputParameterHandler.getValue('sMediaUrl')
        bGetRedirectUrl = oInputParameterHandler.getValue('bGetRedirectUrl')
        sFileName = oInputParameterHandler.getValue('sFileName')

        if bGetRedirectUrl == 'True':
            sMediaUrl = self.__getRedirectUrl(sMediaUrl)

        VSlog(f'Hoster - playlist {sMediaUrl}')
        oHoster = self.getHoster(sHosterIdentifier)
        oHoster.setFileName(sFileName)

        oHoster.setUrl(sMediaUrl)
        aLink = oHoster.getMediaLink()

        if aLink[0]:
            oGuiElement = cGuiElement()
            oGuiElement.setSiteName(self.SITE_NAME)
            oGuiElement.setMediaUrl(aLink[1])
            oGuiElement.setTitle(oHoster.getFileName())

            from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.player import \
                cPlayer
            oPlayer = cPlayer()
            oPlayer.addItemToPlaylist(oGuiElement)
            dialog().VSinfo(str(oHoster.getFileName()), 'Playlist')
            return

        oGui.setEndOfDirectory()

    def __getRedirectUrl(self, sUrl):
        from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.handler.requestHandler import \
            cRequestHandler
        oRequest = cRequestHandler(sUrl)
        oRequest.request()
        return oRequest.getRealUrl()
