# -*- coding: utf-8 -*-
# vStream https://github.com/Kodi-vStream/venom-xbmc-addons
# -*- coding: utf-8 -*-
# zombi https://github.com/zombiB/zombi-addons/

import json
import re
import string

import requests
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.comaddon import (
    addon, siteManager)
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.gui.gui import cGui
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.gui.guiElement import \
    cGuiElement
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.gui.hoster import cHosterGui
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.handler.inputParameterHandler import \
    cInputParameterHandler
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.handler.outputParameterHandler import \
    cOutputParameterHandler
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.handler.requestHandler import \
    cRequestHandler
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.parser import cParser

SITE_IDENTIFIER = 'freebox'
SITE_NAME = '[COLOR orange]Free TV[/COLOR]'
SITE_DESC = 'Watch Livetelevision'

URL_MAIN = siteManager().getUrlMain(SITE_IDENTIFIER)
URL_WEB = 'https://bit.ly/sports4kuhd'

TV_GROUPS = ('http://venom/', 'showGroups')

TV_CHANNELS = ('http://venom/', 'showAllChannels')

Streams = 'api/streams.json'
Channels = 'api/channels.json'
Categories = 'api/categories.json'
Languages = 'api/languages.json'
Countries = 'api/countries.json'
Regions = 'api/regions.json'

TV_TV = (True, 'showMenuTV')

UA = 'Mozilla/5.0 (X11; Linux i686) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/48.0.2564.116 Chrome/48.0.2564.116 Safari/537.36'

sRootArt = ''
ADDON = addon()


class track:
    def __init__(self, length, title, path, icon, data=''):
        self.length = length
        self.title = title
        self.path = path
        self.icon = icon
        self.data = data


def getChannels():
    addons = addon()

    ChannelsJSON = requests.get(URL_MAIN + Channels).json()
    StreamsJSON = requests.get(URL_MAIN + Streams).json()
    ChannelsList = []

    sLang = addons.getSetting('livetv_lang')

    for ch in ChannelsJSON:
        if sLang in ch['languages']:
            for stream in StreamsJSON:
                if stream['channel'] == ch['id']:
                    try:
                        Cat = ch['categories'][0]
                    except:
                        Cat = 'Undefined'
                    channel = {
                        'name': ch['name'],
                        'logo': ch['logo'],
                        'country': ch['country'],
                        'cat': Cat,
                        'url': stream['url'],
                        'referrer': stream['http_referrer'],
                        'ua': stream['user_agent']
                    }
                    ChannelsList.append(channel)

    return ChannelsList


def load():
    oGui = cGui()
    addons = addon()

    oOutputParameterHandler = cOutputParameterHandler()
    oGui.addDir(SITE_IDENTIFIER, 'showMenuTV', addons.VSlang(30115), 'tv.png', oOutputParameterHandler)

    oOutputParameterHandler.addParameter('siteUrl', TV_GROUPS[0])
    oGui.addDir(SITE_IDENTIFIER, TV_GROUPS[1], addons.VSlang(70016), 'genres.png', oOutputParameterHandler)

    oOutputParameterHandler.addParameter('siteUrl', TV_CHANNELS[0])
    oGui.addDir(SITE_IDENTIFIER, TV_CHANNELS[1], addons.VSlang(70017), 'tv.png', oOutputParameterHandler)

    oGui.setEndOfDirectory()


def showGroups():
    oGui = cGui()
    oOutputParameterHandler = cOutputParameterHandler()

    ChannelsList = getChannels()
    oInputParameterHandler = cInputParameterHandler()
    sUrl = oInputParameterHandler.getValue('siteUrl')
    CatsList = []
    for aEntry in ChannelsList:
        CatsList.append(aEntry['cat'])

    CatsList = list(set(CatsList))

    CatsCounter = dict(zip(CatsList, [0] * len(CatsList)))

    for Cat in CatsList:
        for Ch in ChannelsList:
            if Ch['cat'] == Cat:
                CatsCounter[Cat] = CatsCounter[Cat] + 1

    for aEntry in CatsList:
        if aEntry not in [None, "", " "]:
            sTitle = f'{aEntry.title()} ({str(CatsCounter[aEntry])})'
            oOutputParameterHandler.addParameter('siteUrl', sUrl)
            oOutputParameterHandler.addParameter('sTitle', sTitle)
            oOutputParameterHandler.addParameter('sTitle2', aEntry.title())

            oOutputParameterHandler.addParameter('sThumb', '')

            oGui.addDir(SITE_IDENTIFIER, 'showChannels', sTitle, 'genres.png', oOutputParameterHandler)
    oGui.setEndOfDirectory()


def showChannels():
    oGui = cGui()
    oInputParameterHandler = cInputParameterHandler()
    SelectedCat = oInputParameterHandler.getValue('sTitle2')

    ChannelsList = getChannels()

    for aEntry in ChannelsList:

        if SelectedCat in aEntry['cat'].title():

            sHosterUrl = aEntry['url']

            if aEntry['referrer'] not in [None, 'none', '']:
                sHosterUrl += f'|Referrer={aEntry["referrer"]}'

            if aEntry['ua'] not in [None, 'none', '']:
                sHosterUrl += f'|User-Agent={aEntry["ua"]}'

            if (oHoster := cHosterGui().checkHoster(sHosterUrl)):
                oHoster.setDisplayName(aEntry['name'])
                oHoster.setFileName(SelectedCat)
                cHosterGui().showHoster(oGui, oHoster, sHosterUrl, aEntry['logo'])

    oGui.setEndOfDirectory()


def showAllChannels():
    oGui = cGui()
    ChannelsList = getChannels()

    for aEntry in ChannelsList:

        sHosterUrl = aEntry['url']
        if aEntry['referrer'] not in [None, 'none', '']:
            sHosterUrl += f'|Referrer={aEntry["referrer"]}'
        if aEntry['ua'] not in [None, 'none', '']:
            sHosterUrl += f'|User-Agent={aEntry["ua"]}'

        if (oHoster := cHosterGui().checkHoster(sHosterUrl)):
            oHoster.setDisplayName(aEntry['name'])
            oHoster.setFileName(aEntry['name'])
            cHosterGui().showHoster(oGui, oHoster, sHosterUrl, aEntry['logo'])

    oGui.setEndOfDirectory()


def showMenuTV():
    oGui = cGui()
    addons = addon()

    oOutputParameterHandler = cOutputParameterHandler()
    oOutputParameterHandler.addParameter('siteUrl', URL_WEB)
    oGui.addDir(SITE_IDENTIFIER, 'showWeb', addons.VSlang(30332), 'tv.png', oOutputParameterHandler)
    oGui.setEndOfDirectory()


def parseM3U(sUrl=None):  # Traite les m3u local

    if not sUrl:
        oInputParameterHandler = cInputParameterHandler()
        sUrl = oInputParameterHandler.getValue('siteUrl')

    oRequestHandler = cRequestHandler(sUrl)
    oRequestHandler.addHeaderEntry('User-Agent', UA)
    inf = oRequestHandler.request().split('\n')

    playlist = []
    song = track(None, None, None, None)
    ValidEntry = False

    for line in inf:
        line = line.strip()
        if line.startswith('#EXTINF:'):
            length, title = line.split('#EXTINF:')[1].split(',', 1)
            try:
                licon = line.split('#EXTINF:')[1].partition('tvg-logo=')[2]
                icon = licon.split('"')[1]
            except:
                icon = 'tv.png'
            ValidEntry = True
            song = track(length, title, None, icon)

        elif len(line) != 0:
            if ValidEntry and (not (line.startswith('!') or line.startswith('#'))):
                ValidEntry = False
                song.path = line
                playlist.append(song)
                song = track(None, None, None, None)

    return playlist


def showWeb():  # Code qui s'occupe de liens TV du Web
    oGui = cGui()

    oInputParameterHandler = cInputParameterHandler()
    sUrl = oInputParameterHandler.getValue('siteUrl')
    if sUrl == 'TV':
        sUrl = URL_WEB

    playlist = parseM3U(sUrl=sUrl)

    if oInputParameterHandler.exist('AZ'):
        sAZ = oInputParameterHandler.getValue('AZ')
        string = filter(lambda t: t.title.strip().capitalize().startswith(sAZ), playlist)
        playlist = sorted(string, key=lambda t: t.title.strip().capitalize())
    else:
        playlist = sorted(playlist, key=lambda t: t.title.strip().capitalize())

    if not playlist:
        oOutputParameterHandler = cOutputParameterHandler()
        oOutputParameterHandler.addParameter('siteUrl', 'http://')
        oGui.addText(SITE_IDENTIFIER, '[COLOR red]Error getting playlist[/COLOR]')

    else:
        for track in playlist:
            sThumb = track.icon
            if not sThumb:
                sThumb = 'https://raw.githubusercontent.com/Yonn1981/Repo/master/repo/plugin.video.matrix/resources/art/tv.png'

            # les + ne peuvent pas passer
            url2 = track.path.replace('+', 'P_L_U_S')

            thumb = ''.join([sRootArt, sThumb])

            oOutputParameterHandler = cOutputParameterHandler()
            oOutputParameterHandler.addParameter('siteUrl', url2)
            oOutputParameterHandler.addParameter('sMovieTitle', track.title)
            oOutputParameterHandler.addParameter('sThumbnail', thumb)

            if (oHoster := cHosterGui().getHoster('lien_direct')):
                oHoster.setDisplayName(track.title)
                oHoster.setFileName(track.title)
                cHosterGui().showHoster(oGui, oHoster, url2, sThumb)

    oGui.setEndOfDirectory()


def showAZ():
    oGui = cGui()
    oInputParameterHandler = cInputParameterHandler()
    sUrl = oInputParameterHandler.getValue('siteUrl')

    oOutputParameterHandler = cOutputParameterHandler()
    for i in string.digits:
        oOutputParameterHandler.addParameter('siteUrl', sUrl)
        oOutputParameterHandler.addParameter('AZ', i)
        oGui.addDir(SITE_IDENTIFIER, 'showTV', i, 'az.png', oOutputParameterHandler)

    for i in string.ascii_uppercase:
        oOutputParameterHandler.addParameter('siteUrl', sUrl)
        oOutputParameterHandler.addParameter('AZ', i)
        oGui.addDir(SITE_IDENTIFIER, 'showTV', i, 'az.png', oOutputParameterHandler)

    oGui.setEndOfDirectory()


def showTV():
    oGui = cGui()
    oInputParameterHandler = cInputParameterHandler()
    sUrl = oInputParameterHandler.getValue('siteUrl')

    oRequestHandler = cRequestHandler(sUrl)
    sHtmlContent = oRequestHandler.request()

    oParser = cParser()
    sPattern = '<title>(.+?)</title><link>(.+?)</link>'
    aResult = oParser.parse(sHtmlContent, sPattern)

    if aResult[0]:

        if oInputParameterHandler.exist('AZ'):
            sAZ = oInputParameterHandler.getValue('AZ')
            string = filter(lambda t: t[0].strip().capitalize().startswith(sAZ), aResult[1])
            string = sorted(string, key=lambda t: t[0].strip().capitalize())
        else:
            string = sorted(aResult[1], key=lambda t: t[0].strip().capitalize())

        oOutputParameterHandler = cOutputParameterHandler()
        for aEntry in string:

            oOutputParameterHandler.addParameter('siteUrl', aEntry[1])
            oOutputParameterHandler.addParameter('sMovieTitle', aEntry[0])
            oOutputParameterHandler.addParameter('sThumbnail', 'tv.png')

            if (oHoster := cHosterGui().getHoster('lien_direct')):
                oHoster.setDisplayName(track.title)
                oHoster.setFileName(track.title)
                cHosterGui().showHoster(oGui, oHoster, aEntry[1], 'tv.png')

    oGui.setEndOfDirectory()


def play__():  # Lancer les liens
    addons = addon()
    oGui = cGui()

    Iuser = addons.getSetting('hoster_iptvt_username')
    Ipass = addons.getSetting('hoster_iptvt_password')
    oInputParameterHandler = cInputParameterHandler()
    sUrl = oInputParameterHandler.getValue('siteUrl').replace('P_L_U_S', '+').replace('username', Iuser).replace('password', Ipass)
    sTitle = oInputParameterHandler.getValue('sMovieTitle')
    sThumbnail = oInputParameterHandler.getValue('sThumbnail')
    sDesc = oInputParameterHandler.getValue('sDesc')

    # Special url with tag
    if '[' in sUrl and ']' in sUrl:
        sUrl = getRealUrl(sUrl)

    # Bug specifique au flux france TV
    # eof detectedL
    if 'youtube' in sUrl:
        if (oHoster := cHosterGui().checkHoster(sUrl)):
            oHoster.setDisplayName(sTitle)
            oHoster.setFileName(sTitle)
            cHosterGui().showHoster(oGui, oHoster, sUrl, sThumbnail)

    else:
        oGuiElement = cGuiElement()
        oGuiElement.setSiteName(SITE_IDENTIFIER)
        oGuiElement.setTitle(sTitle)
        sUrl = sUrl.replace(' ', '%20')
        oGuiElement.setMediaUrl(sUrl)
        oGuiElement.setThumbnail(sThumbnail)
        oGuiElement.setDescription(sDesc)

        from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.player import \
            cPlayer
        oPlayer = cPlayer()
        oPlayer.clearPlayList()
        oPlayer.addItemToPlaylist(oGuiElement)
        oPlayer.startPlayer()

        return False, False

    oGui.setEndOfDirectory()


"""
Fonction diverse:
#   - getRealUrl = Regex pour Iptv(Officiel)
#   - showDailymotionStream = Lis les liens de streaming de Daylimotion qui sont speciaux
#   - getBrightcoveKey = Recupere le token pour les liens proteger par Brightcove (RMC Decouvert par exemple)
"""


def getRealUrl(chain):
    oParser = cParser()

    UA2 = UA
    url = chain
    regex = ''
    param = ""
    head = None

    if (r := re.search('\[[DECODENRJ]+\](.+?)(?:(?:\[[A-Z]+\])|$)', chain)):
        url = decodeNrj(r.group(1))

    if (r := re.search('\[[BRIGHTCOVEKEY]+\](.+?)(?:(?:\[[A-Z]+\])|$)', chain)):
        url = getBrightcoveKey(r.group(1))

    if (r := re.search('\[[REGEX]+\](.+?)(?:(?:\[[A-Z]+\])|$)', chain)):
        regex = r.group(1)

    if (r := re.search('\[[UA]+\](.+?)(?:(?:\[[A-Z]+\])|$)', chain)):
        UA2 = r.group(1)

    if (r := re.search('\[[URL]+\](.+?)(?:(?:\[[A-Z]+\])|$)', chain)):
        url = r.group(1)

    if (r := re.search('\[[HEAD]+\](.+?)(?:(?:\[[A-Z]+\])|$)', chain)):
        head = r.group(1)

    # post metehod ?
    if (r := re.search('\[[POSTFORM]+\](.+?)(?:(?:\[[A-Z]+\])|$)', chain)):
        param = r.group(1)

    oRequestHandler = cRequestHandler(url)
    if param:
        oRequestHandler.setRequestType(1)
        oRequestHandler.addHeaderEntry('Accept-Encoding', 'identity')
        oRequestHandler.addParametersLine(param)
    if head:
        head = json.loads(head)
        for a in head:
            oRequestHandler.addHeaderEntry(a, head[a])
    sHtmlContent = oRequestHandler.request()

    if regex:
        if (aResult2 := oParser.parse(sHtmlContent, regex)):
            url = aResult2[1][0]

    url += f'|User-Agent={UA2}'

    return url


def decodeNrj(d):
    oRequestHandler = cRequestHandler(d)
    sHtmlContent = oRequestHandler.request()

    title = re.search('''data-program_title=['"]([^"^']+?)['"]''', sHtmlContent).group(1)
    ids = re.search('''data-ref=['"]([^"^']+?)['"]''', sHtmlContent).group(1)

    url = f'https://www.nrj-play.fr/compte/live?channel={d.split("/")[3]}&channel={d.split("/")[3]}&title='
    url += f'{title}&channel={d.split("/")[3]}&ref={ids}&formId=formDirect'

    oRequestHandler = cRequestHandler(url)
    sHtmlContent = oRequestHandler.request()
    dataUrl = re.search('''['"]contentUrl['"] content=['"]([^"^']+?)['"]''', sHtmlContent).group(1)

    return dataUrl


def getBrightcoveKey(sUrl):
    oRequestHandler = cRequestHandler(sUrl)
    sHtmlContent = oRequestHandler.request()

    if "rmcdecouverte" in sUrl:
        url = re.search('''<script type=['"]application/javascript['"] src=['"]([^"^']+?)['"]></script>''', sHtmlContent).group(1)

        oRequestHandler = cRequestHandler(f"https://{sUrl.split('/')[2]}{url}")
        sHtmlContent = oRequestHandler.request()
        result = re.search('''N=['"]([^"^']+?)['"],y=['"]([^"^']+?)['"]\)''', sHtmlContent)
        player = result.group(1)
        video = result.group(2)

        oRequestHandler = cRequestHandler("https://static.bfmtv.com/ressources/next-player/cleo-player/playerBridge.js")
        sHtmlContent = oRequestHandler.request().lower()

        ID = sUrl.split('/')[2].split('.')[0]
        account = re.search(f"\n(.+?): '{ID}'", sHtmlContent).group(1).replace('            ', '')

    else:
        result = re.search('''<div class=['"]video_block['"] id=['"]video_player_.+?['"] accountid=['"]([^"^']+?)['"] playerid=['"]([^"^']+?)['"] videoid=['"]([^"^']+?)['"]''', sHtmlContent)

        account = result.group(1)
        player = result.group(2)
        video = result.group(3)

    url = f'http://players.brightcove.net/{account}/{player}_default/index.min.js'
    oRequestHandler = cRequestHandler(url)
    sHtmlContent = oRequestHandler.request()
    policyKey = re.search('''policyKey:['"]([^"^']+?)['"]''', sHtmlContent).group(1)

    url = f"https://edge.api.brightcove.com/playback/v1/accounts/{account}/videos/{video}"
    oRequestHandler = cRequestHandler(url)
    oRequestHandler.addHeaderEntry('Accept', f"application/json;pk={policyKey}")
    sHtmlContent = oRequestHandler.request()
    url = re.search('''['"]sources['"]:.+?src['"]:['"]([^"^']+?)['"]''', sHtmlContent).group(1)

    return url
